package mysqladdress

import (
	"context"
	"database/sql"
	"errors"

	errmsg "git.gocasts.ir/ebhomengo/niki/pkg/err_msg"
	richerror "git.gocasts.ir/ebhomengo/niki/pkg/rich_error"
)

func (d *DB) IsExistProvinceByID(ctx context.Context, id uint) (bool, error) {
	const op = "mysqladdress.IsExistProvinceByID"

	row := d.conn.Conn().QueryRowContext(ctx, `select * from provinces where id = ?`, id)

	_, err := scanProvince(row)
	if err != nil {
		sErr := sql.ErrNoRows
		//TODO-errorsas: second argument to errors.As should not be *error
		//nolint
		if errors.As(err, &sErr) {
			return false, nil
		}

		// TODO - log unexpected error for better observability
		return false, richerror.New(op).WithErr(err).
			WithMessage(errmsg.ErrorMsgCantScanQueryResult).WithKind(richerror.KindUnexpected)
	}

	return true, nil
}
